﻿using System;
using Random = UnityEngine.Random;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace MVRPlugin {
	public class Template : MVRScript {

		// IMPORTANT - DO NOT make custom enums. The dynamic C# complier crashes Unity when it encounters these for
		// some reason
		private static Atom person;
        private static FreeControllerV3 lShoulderController;
        private static FreeControllerV3 rShoulderController;
        private static FreeControllerV3 lArmController;
        private static FreeControllerV3 rArmController;
        private static FreeControllerV3 lHandController;
        private static FreeControllerV3 rHandController;
        private static FreeControllerV3 abdomenController;
        private static FreeControllerV3 pelvisController;
        private static FreeControllerV3 chestController;
        private static FreeControllerV3 lNippleController;
        private static FreeControllerV3 rNippleController;
        private static FreeControllerV3 neckController;
        private static FreeControllerV3 headController;
        private static FreeControllerV3 lHipController;
        private static FreeControllerV3 rHipController;
        private static FreeControllerV3 lKneeController;
        private static FreeControllerV3 rKneeController;
        private static FreeControllerV3 lFootController;
        private static FreeControllerV3 rFootController;
        private static FreeControllerV3 lToeController;
        private static FreeControllerV3 rToeController;
		
		private static string person2String = "None";
		private static Atom person2;
        private static FreeControllerV3 lShoulderController2;
        private static FreeControllerV3 rShoulderController2;
        private static FreeControllerV3 lArmController2;
        private static FreeControllerV3 rArmController2;
        private static FreeControllerV3 lHandController2;
        private static FreeControllerV3 rHandController2;
        private static FreeControllerV3 abdomenController2;
        private static FreeControllerV3 pelvisController2;
        private static FreeControllerV3 chestController2;
        private static FreeControllerV3 lNippleController2;
        private static FreeControllerV3 rNippleController2;
        private static FreeControllerV3 neckController2;
        private static FreeControllerV3 headController2;
        private static FreeControllerV3 lHipController2;
        private static FreeControllerV3 rHipController2;
        private static FreeControllerV3 lKneeController2;
        private static FreeControllerV3 rKneeController2;
        private static FreeControllerV3 lFootController2;
        private static FreeControllerV3 rFootController2;
        private static FreeControllerV3 lToeController2;
        private static FreeControllerV3 rToeController2;


		protected JSONStorableBool uianimatehandl;
		protected JSONStorableBool uianimatehandr;
		protected JSONStorableBool uigenericcol;
		protected JSONStorableFloat uimotionspeed;
		protected JSONStorableFloat uianimationspeed;
		protected JSONStorableFloat uidistancescale;
		protected JSONStorableFloat uiposeadjust;
		protected JSONStorableFloat uithumbadjust;
		protected JSONStorableFloat uigraspadjust;
		protected JSONStorableFloat uistraightenadjust;
		protected JSONStorableFloat uichopadjust;
		protected JSONStorableFloat uithumboffset;
		protected JSONStorableFloat uifingercurl;
		protected JSONStorableBool uidowalk;
		protected JSONStorableFloat uitoebaseangleoffset;
		protected JSONStorableFloat uitoemaxangle;
		protected JSONStorableFloat uitoeground;
		protected JSONStorableFloat uitoegroundclear;
		protected JSONStorableBool uiShowStats;
		protected JSONStorableStringChooser uiTargetSelection;
		protected JSONStorableBool uiSkipOwnHands;
		
		private static Atom currentAtom;
		private static string currentAtomName;
		
        private static DAZMorph morphLHandFist;
        private static float mLHandFistValue = 0.0f;
        private static float mLHandFistTarget = 0.0f;
        private static DAZMorph morphRHandFist;
        private static float mRHandFistValue = 0.0f;
        private static float mRHandFistTarget = 0.0f;

        private static DAZMorph morphLThumbGrasp;
        private static DAZMorph morphRThumbGrasp;
        private static DAZMorph morphLThumbFist;
        private static DAZMorph morphRThumbFist;
        private static DAZMorph morphLThumbInOut;
        private static DAZMorph morphRThumbInOut;
        private static DAZMorph morphLHandChop;

        private static DAZMorph morphLPinkyBend;
        private static DAZMorph morphRPinkyBend;
        private static DAZMorph morphLRingBend;
        private static DAZMorph morphRRingBend;
        private static DAZMorph morphLMiddleBend;
        private static DAZMorph morphRMiddleBend;
        private static DAZMorph morphLIndexBend;
        private static DAZMorph morphRIndexBend;


        private static float mLHandChopValue = 0.0f;
        private static float mLHandChopTarget = 0.0f;
        private static DAZMorph morphRHandChop;
        private static float mRHandChopValue = 0.0f;
        private static float mRHandChopTarget = 0.0f;
        private static DAZMorph morphLHandStraighten;
        private static float mLHandStraightenValue = 0.0f;
        private static float mLHandStraightenTarget = 0.0f;
        private static DAZMorph morphRHandStraighten;
        private static float mRHandStraightenValue = 0.0f;
        private static float mRHandStraightenTarget = 0.0f;
		private static float lHandCollisionTimer = 0.0f;
		private static float rHandCollisionTimer = 0.0f;
		private static float toeAmount = 0.0f;
		private static float rthumbOutActual = 0.0f;
		private static float lthumbOutActual = 0.0f;
		private static float lhandcurlActual = 0.0f;
		private static float rhandcurlActual = 0.0f;
		
		
		private static float lHandRelaxAmount = 0.0f;
		private static float lHandRelaxAmountActual = 0.0f;
		private static float rHandRelaxAmount = 0.0f;
		private static float rHandRelaxAmountActual = 0.0f;
		private static float lHandRelaxActual = 0.0f;
		private static float rHandRelaxActual = 0.0f;
		
		private static string lhanddebugold = "";
		private static string rhanddebugold = "";
		private static string lhanddebug = "";
		private static string rhanddebug = "";
		private static string lToeDebug = "";
		private static string rToeDebug = "";
		
		private static float morphBufferL = 0.1f;
		private static float poseSwitchCountL = 0.0f;
		private static float morphBufferR = 0.1f;
		private static float poseSwitchCountR = 0.0f;
		
		protected Vector3 lhandpos;
		protected Vector3 rhandpos;
		protected Vector3 lcurhandpos;
		protected Vector3 rcurhandpos;
		
		private static float randomTimer = 0.0f;
		private static float randomValueL = 0.0f;
		private static float randomValueR = 0.0f;
		
		// IMPORTANT - DO NOT OVERRIDE Awake() as it is used internally by MVRScript - instead use Init() function which
		// is called right after creation
		public override void Init() {
			try {
				// put init code in here
				SuperController.LogMessage("Hand Animator v3 Loaded");
				person = containingAtom;
                headController = person.GetStorableByID("headControl") as FreeControllerV3;
                neckController = person.GetStorableByID("neckControl") as FreeControllerV3;
                chestController = person.GetStorableByID("chestControl") as FreeControllerV3;
                lNippleController = person.GetStorableByID("lNippleControl") as FreeControllerV3;
                rNippleController = person.GetStorableByID("rNippleControl") as FreeControllerV3;
                abdomenController = person.GetStorableByID("abdomen2Control") as FreeControllerV3;
                pelvisController = person.GetStorableByID("pelvisControl") as FreeControllerV3;
                lShoulderController = person.GetStorableByID("lShoulderControl") as FreeControllerV3;
                rShoulderController = person.GetStorableByID("rShoulderControl") as FreeControllerV3;
                lArmController = person.GetStorableByID("lArmControl") as FreeControllerV3;
                rArmController = person.GetStorableByID("rArmControl") as FreeControllerV3;
                lHandController = person.GetStorableByID("lHandControl") as FreeControllerV3;
                rHandController = person.GetStorableByID("rHandControl") as FreeControllerV3;
                lHipController = person.GetStorableByID("lThighControl") as FreeControllerV3;
                rHipController = person.GetStorableByID("rThighControl") as FreeControllerV3;
                lKneeController = person.GetStorableByID("lKneeControl") as FreeControllerV3;
                rKneeController = person.GetStorableByID("rKneeControl") as FreeControllerV3;
                lFootController = person.GetStorableByID("lFootControl") as FreeControllerV3;
                rFootController = person.GetStorableByID("rFootControl") as FreeControllerV3;
                lToeController = person.GetStorableByID("lToeControl") as FreeControllerV3;
                rToeController = person.GetStorableByID("rToeControl") as FreeControllerV3;
				
				lhandpos = lcurhandpos;
				rhandpos = rHandController.followWhenOff.position;
				
                JSONStorable js = person.GetStorableByID("geometry");
                DAZCharacterSelector dcs = js as DAZCharacterSelector;
                GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;
				morphLHandFist = morphUI.GetMorphByDisplayName("Left Hand Grasp");
				morphRHandFist = morphUI.GetMorphByDisplayName("Right Hand Grasp");
				morphLThumbGrasp = morphUI.GetMorphByDisplayName("Left Thumb Bend");
				morphRThumbGrasp = morphUI.GetMorphByDisplayName("Right Thumb Bend");
				morphLThumbFist = morphUI.GetMorphByDisplayName("Left Thumb Fist");
				morphRThumbFist = morphUI.GetMorphByDisplayName("Right Thumb Fist");
				morphLThumbInOut = morphUI.GetMorphByDisplayName("Left Thumb In-Out");
				morphRThumbInOut = morphUI.GetMorphByDisplayName("Right Thumb In-Out");
				morphLHandChop = morphUI.GetMorphByDisplayName("Left Hand Chop");
				morphRHandChop = morphUI.GetMorphByDisplayName("Right Hand Chop");
				morphLHandStraighten = morphUI.GetMorphByDisplayName("Left Hand Straighten");
				morphRHandStraighten = morphUI.GetMorphByDisplayName("Right Hand Straighten");

				morphLPinkyBend = morphUI.GetMorphByDisplayName("Left Pinky Finger Bend");
				morphRPinkyBend = morphUI.GetMorphByDisplayName("Right Pinky Finger Bend");
				morphLRingBend = morphUI.GetMorphByDisplayName("Left Ring Finger Bend");
				morphRRingBend = morphUI.GetMorphByDisplayName("Right Ring Finger Bend");
				morphLMiddleBend = morphUI.GetMorphByDisplayName("Left Mid Finger Bend");
				morphRMiddleBend = morphUI.GetMorphByDisplayName("Right Mid Finger Bend");
				morphLIndexBend = morphUI.GetMorphByDisplayName("Left Index Finger Bend");
				morphRIndexBend = morphUI.GetMorphByDisplayName("Right Index Finger Bend");

				


			uianimatehandl = new JSONStorableBool("Dynamically Adjust L Hand Morphs", true);
			RegisterBool(uianimatehandl);
			CreateToggle(uianimatehandl, true);
			uianimatehandr = new JSONStorableBool("Dynamically Adjust R Hand Morphs", true);
			RegisterBool(uianimatehandr);
			CreateToggle(uianimatehandr, true);
			uigenericcol = new JSONStorableBool("flatten on any surface (buggy)", false);
			RegisterBool(uigenericcol);
			CreateToggle(uigenericcol, true);
			uiShowStats = new JSONStorableBool("Show stats on message log", false);
			RegisterBool(uiShowStats);
			CreateToggle(uiShowStats, true);
			uiposeadjust = new JSONStorableFloat("Static Pose Modifier", 0.4f, 0.0f, 2.0f, true, true);
			RegisterFloat(uiposeadjust);
			CreateSlider(uiposeadjust, true);
			uigraspadjust = new JSONStorableFloat("Grasp Morph Modifier", 1.0f, 0.0f, 2.0f, true, true);
			RegisterFloat(uigraspadjust);
			CreateSlider(uigraspadjust, true);
			uistraightenadjust = new JSONStorableFloat("Straighten Morph Modifier", 1.5f, 0.0f, 2.0f, true, true);
			RegisterFloat(uistraightenadjust);
			CreateSlider(uistraightenadjust, true);
			uichopadjust = new JSONStorableFloat("Chop Morph Modifier", 0.5f, 0.0f, 2.0f, true, true);
			RegisterFloat(uichopadjust);
			CreateSlider(uichopadjust, true);
			uithumbadjust = new JSONStorableFloat("Thumbs Morphs Modifier", 0.3f, 0.0f, 2.0f, true, true);
			RegisterFloat(uithumbadjust);
			CreateSlider(uithumbadjust, true);
			uithumboffset = new JSONStorableFloat("Thumbs Position Offset", 0.17f, -1.0f, 1.0f, true, true);
			RegisterFloat(uithumboffset);
			CreateSlider(uithumboffset, true);
			uimotionspeed = new JSONStorableFloat("Motion Speed Scale", 1.0f, 0.0f, 5.0f, true, true);
			RegisterFloat(uimotionspeed);
			CreateSlider(uimotionspeed, false);
			uidistancescale = new JSONStorableFloat("Distance Scale", 1.06f, 0.0f, 5.0f, true, true);
			RegisterFloat(uidistancescale);
			CreateSlider(uidistancescale, false);
			uianimationspeed = new JSONStorableFloat("Animation Speed", 2.0f, 0.0f, 5.0f, true, true);
			RegisterFloat(uianimationspeed);
			CreateSlider(uianimationspeed, false);
			uifingercurl = new JSONStorableFloat("Relaxed finger curl", 1.0f, -1.0f, 2.0f, true, true);
			RegisterFloat(uifingercurl);
			CreateSlider(uifingercurl, false);

			uitoeground = new JSONStorableFloat("Ground Level", 0.0f, -5.0f, 5.0f, true, true);
			RegisterFloat(uitoeground);
			CreateSlider(uitoeground, false);
			uitoegroundclear = new JSONStorableFloat("Ground Clearance", 0.1f, -5.0f, 5.0f, true, true);
			RegisterFloat(uitoegroundclear);
			CreateSlider(uitoegroundclear, false);
			uidowalk = new JSONStorableBool("Walk:Adjust Toes", false);
			RegisterBool(uidowalk);
			CreateToggle(uidowalk, false);
			uitoebaseangleoffset = new JSONStorableFloat("Walk:Foot Angle Offset", 10.0f, -90.0f, 90.0f, true, true);
			RegisterFloat(uitoebaseangleoffset);
			CreateSlider(uitoebaseangleoffset, false);
			uitoemaxangle = new JSONStorableFloat("Walk:Toe Max Up Angle", 30.0f, 0.0f, 90.0f, true, true);
			RegisterFloat(uitoemaxangle);
			CreateSlider(uitoemaxangle, false);
			
			List<string> targetChoices = new List<string>();
			foreach (string atomUID in SuperController.singleton.GetAtomUIDs())
			{
				currentAtom = SuperController.singleton.GetAtomByUid(atomUID);
				if (currentAtom != containingAtom && atomUID != null && currentAtom.type == "Person")
				{
					targetChoices.Add(atomUID);
				}
			}
			uiTargetSelection = new JSONStorableStringChooser("Target Selector", targetChoices, "None", "Choose Person");
			RegisterStringChooser(uiTargetSelection);
			UIDynamicPopup udp = CreatePopup(uiTargetSelection, true);

			uiSkipOwnHands = new JSONStorableBool("Skip Own Hands", false);
			RegisterBool(uiSkipOwnHands);
			CreateToggle(uiSkipOwnHands, false);

			
				// create custom JSON storable params here if you want them to be stored with scene JSON
				// types are JSONStorableFloat, JSONStorableBool, JSONStorableString, JSONStorableStringChooser
				// JSONStorableColor

			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// Start is called once before Update or FixedUpdate is called and after Init()
		void Start() {
			try {
				// put code in here
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}


		// FixedUpdate is called with each physics simulation frame by Unity
		void Update() {
			try {
				// put code in here
				if (uiTargetSelection.val != "None")
				{
					if (person2String != uiTargetSelection.val)
					{
						currentAtom = SuperController.singleton.GetAtomByUid(uiTargetSelection.val);
						if (currentAtom != null)
						{
							person2String = uiTargetSelection.val;
							person2 = currentAtom;
							headController2 = person2.GetStorableByID("headControl") as FreeControllerV3;
							neckController2 = person2.GetStorableByID("neckControl") as FreeControllerV3;
							chestController2 = person2.GetStorableByID("chestControl") as FreeControllerV3;
							lNippleController2 = person2.GetStorableByID("lNippleControl") as FreeControllerV3;
							rNippleController2 = person2.GetStorableByID("rNippleControl") as FreeControllerV3;
							abdomenController2 = person2.GetStorableByID("abdomen2Control") as FreeControllerV3;
							pelvisController2 = person2.GetStorableByID("pelvisControl") as FreeControllerV3;
							lShoulderController2 = person2.GetStorableByID("lShoulderControl") as FreeControllerV3;
							rShoulderController2 = person2.GetStorableByID("rShoulderControl") as FreeControllerV3;
							lArmController2 = person2.GetStorableByID("lArmControl") as FreeControllerV3;
							rArmController2 = person2.GetStorableByID("rArmControl") as FreeControllerV3;
							lHandController2 = person2.GetStorableByID("lHandControl") as FreeControllerV3;
							rHandController2 = person2.GetStorableByID("rHandControl") as FreeControllerV3;
							lHipController2 = person2.GetStorableByID("lThighControl") as FreeControllerV3;
							rHipController2 = person2.GetStorableByID("rThighControl") as FreeControllerV3;
							lKneeController2 = person2.GetStorableByID("lKneeControl") as FreeControllerV3;
							rKneeController2 = person2.GetStorableByID("rKneeControl") as FreeControllerV3;
							lFootController2 = person2.GetStorableByID("lFootControl") as FreeControllerV3;
							rFootController2 = person2.GetStorableByID("rFootControl") as FreeControllerV3;
							lToeController2 = person2.GetStorableByID("lToeControl") as FreeControllerV3;
							rToeController2 = person2.GetStorableByID("rToeControl") as FreeControllerV3;
						}
						else
						{
							uiTargetSelection.val = "None";
							person2String = uiTargetSelection.val;
							person2 = null;
							headController2 = null;
							neckController2 = null;
							chestController2 = null;
							lNippleController2 = null;
							rNippleController2 = null;
							abdomenController2 = null;
							pelvisController2 = null;
							lShoulderController2 = null;
							rShoulderController2 = null;
							lArmController2 = null;
							rArmController2 = null;
							lHandController2 = null;
							rHandController2 = null;
							lHipController2 = null;
							rHipController2 = null;
							lFootController2 = null;
							rFootController2 = null;
							lToeController2 = null;
							rToeController2 = null;
						}
					}
				}
				
				float minHeadDist = 0.08f * uidistancescale.val;
				float minChestDist = 0.21f * uidistancescale.val;
				float minNippleDist = 0.1f  * uidistancescale.val;
				float minAbsDist = 0.12f * uidistancescale.val;
				float minHipDist = 0.18f * uidistancescale.val;
				float minHandDist = 0.14f * uidistancescale.val;
				float minThighDist = 0.17f * uidistancescale.val;
				float minPelvisDist = 0.05f * uidistancescale.val;
        float minKneeDist = 0.2f * uidistancescale.val;
				float minMotion = 0.2f;
				float maxStraighten = 1.0f;
				float maxFist = 1.0f;
				float maxChop = 1.0f;
				
				lhanddebug = "Left Hand : ";
				rhanddebug = "Right Hand : ";
				RaycastHit hit;
				float hitDist = 0.0f;
				bool hitdetected = false;
				lcurhandpos = lHandController.followWhenOff.TransformPoint(new Vector3(-0.1f, 0.0f, 0.0f));
				rcurhandpos = rHandController.followWhenOff.TransformPoint(new Vector3(0.1f, 0.0f, 0.0f));

				float lhipLDist = Vector3.Distance(lcurhandpos, lHipController.followWhenOff.position);
				float lhipRDist = Vector3.Distance(lcurhandpos, rHipController.followWhenOff.position);
				float lkneeLDist = Vector3.Distance(lcurhandpos, lKneeController.followWhenOff.position);
				float lkneeRDist = Vector3.Distance(lcurhandpos, rKneeController.followWhenOff.position);
				float lthighLDist = Vector3.Distance(lcurhandpos, lHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
				float lthighRDist = Vector3.Distance(lcurhandpos, rHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
				float lpelvisDist = Vector3.Distance(lcurhandpos, pelvisController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.17f,0.04f)));
				float lchestDist = Vector3.Distance(lcurhandpos, chestController.followWhenOff.position);
				float lnippleLDist = Vector3.Distance(lcurhandpos, lNippleController.followWhenOff.position);
				float lnippleRDist = Vector3.Distance(lcurhandpos, rNippleController.followWhenOff.position);
				float labsDist = Vector3.Distance(lcurhandpos, abdomenController.followWhenOff.position);
				float lheadDist = Vector3.Distance(lcurhandpos, headController.followWhenOff.position);
				float lrhandDist = Vector3.Distance(lcurhandpos, rcurhandpos);
				if (uiSkipOwnHands.val == true)
				{
					lrhandDist = 99999.0f;
				}
				float lmoveDist = Vector3.Distance(lcurhandpos, lhandpos) * uimotionspeed.val;
				float lfloorDist = Mathf.Max(lcurhandpos.y, uitoeground.val);
				float lhandCurl = 1.0f;
				float lthumbOut = 0.0f;
				lHandRelaxAmount = 0.0f;

				float lhipLDist2 = 99999.0f;
				float lhipRDist2 = 99999.0f;
				float lkneeLDist2 = 99999.0f;
				float lkneeRDist2 = 99999.0f;
				float lthighLDist2 = 99999.0f;
				float lthighRDist2 = 99999.0f;
				float lpelvisDist2 = 99999.0f;
				float lchestDist2 = 99999.0f;
				float lnippleLDist2 = 99999.0f;
				float lnippleRDist2 = 99999.0f;
				float labsDist2 = 99999.0f;
				float lheadDist2 = 99999.0f;
				float llhandDist2 = 99999.0f;
				float lrhandDist2 = 99999.0f;
				
				randomTimer += Time.fixedDeltaTime;
				if (randomTimer > 0.5f)
				{
					randomValueL = Random.Range(0.4f,1.5f);
					randomValueR = Random.Range(0.4f,1.5f);
					randomTimer = Random.Range(-2.0f,-0.25f);
				}
				
				
				if (uianimatehandl.val)
				{

					Vector3 lhanddir = chestController.followWhenOff.position - lcurhandpos;
					float ldotProduct = Vector3.Dot(lhanddir, chestController.followWhenOff.forward);
					float ldotProduct2;

					if (uiTargetSelection.val != "None")
					{
						lhipLDist2 = Vector3.Distance(lcurhandpos, lHipController2.followWhenOff.position);
						lhipRDist2 = Vector3.Distance(lcurhandpos, rHipController2.followWhenOff.position);
						lkneeLDist2 = Vector3.Distance(lcurhandpos, lKneeController2.followWhenOff.position);
						lkneeRDist2 = Vector3.Distance(lcurhandpos, rKneeController2.followWhenOff.position);
						lthighLDist2 = Vector3.Distance(lcurhandpos, lHipController2.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
						lthighRDist2 = Vector3.Distance(lcurhandpos, rHipController2.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
						lpelvisDist2 = Vector3.Distance(lcurhandpos, pelvisController2.followWhenOff.TransformPoint(new Vector3(0.0f,-0.17f,0.04f)));
						lchestDist2 = Vector3.Distance(lcurhandpos, chestController2.followWhenOff.position);
						lnippleLDist2 = Vector3.Distance(lcurhandpos, lNippleController2.followWhenOff.position);
						lnippleRDist2 = Vector3.Distance(lcurhandpos, rNippleController2.followWhenOff.position);
						labsDist2 = Vector3.Distance(lcurhandpos, abdomenController2.followWhenOff.position);
						lheadDist2 = Vector3.Distance(lcurhandpos, headController2.followWhenOff.position);
						llhandDist2 = Vector3.Distance(lcurhandpos, lHandController2.followWhenOff.TransformPoint(new Vector3(-0.1f, 0.0f, 0.0f)));
						lrhandDist2 = Vector3.Distance(lcurhandpos, rHandController2.followWhenOff.TransformPoint(new Vector3(0.1f, 0.0f, 0.0f)));
						ldotProduct2 = Vector3.Dot(lhanddir, chestController2.followWhenOff.forward);
					}
										
					if (lmoveDist > minMotion ||
					    ((lchestDist > minChestDist && labsDist > minAbsDist && lheadDist > minHeadDist && lhipLDist > minHipDist && lhipRDist > minHipDist && lnippleLDist > minNippleDist && lnippleRDist > minNippleDist && lthighLDist > minThighDist && lthighRDist > minThighDist && lpelvisDist > minPelvisDist)
						&& (lchestDist2 > minChestDist && labsDist2 > minAbsDist && lheadDist2 > minHeadDist && lhipLDist2 > minHipDist && lhipRDist2 > minHipDist && lnippleLDist2 > minNippleDist && lnippleRDist2 > minNippleDist && lthighLDist2 > minThighDist && lthighRDist2 > minThighDist && lpelvisDist2 > minPelvisDist)))
					{
						if (lmoveDist > 0.02f)
						{
							mLHandStraightenTarget = maxStraighten;
							mLHandFistTarget = 0.0f;
							lhandCurl = 0.0f;
							lHandRelaxAmount = 0.0f;
							lhanddebug += " FastMove";
						}
						else
						{
							mLHandStraightenTarget = 0.0f;
							mLHandFistTarget = maxFist * 0.2f * uiposeadjust.val;
							lHandRelaxAmount = 1.0f;
							lthumbOut = -0.1f;
							lhanddebug += " Slow";
						}

						if (lcurhandpos.y > neckController.followWhenOff.position.y && lheadDist < 0.15f * uidistancescale.val)
						{
							if (lcurhandpos.y < headController.followWhenOff.position.y + 0.15f)
							{
								mLHandStraightenTarget = 0.9f;
								mLHandFistTarget = 0 * (Mathf.Clamp(lmoveDist*10.0f, 0.0f, 1.0f));
								lthumbOut = -0.1f;
								lhanddebug += " ParHead";
							}
							else
							{
								mLHandStraightenTarget = Mathf.Lerp(0.3f, maxStraighten, Mathf.Clamp(lmoveDist*10.0f, 0.0f, 1.0f));
								mLHandFistTarget = 0.0f;
								lhanddebug += " AboveHead";
							}
						}

						if (uiTargetSelection.val != "None")
						{
							if (lcurhandpos.y > neckController2.followWhenOff.position.y && lheadDist2 < 0.15f * uidistancescale.val)
							{
								if (lcurhandpos.y < headController2.followWhenOff.position.y + 0.15f)
								{
									mLHandStraightenTarget = 0.9f;
									mLHandFistTarget = 0 * (Mathf.Clamp(lmoveDist*10.0f, 0.0f, 1.0f));
									lthumbOut = -0.1f;
									lhanddebug += " ParHead";
								}
								else
								{
									mLHandStraightenTarget = Mathf.Lerp(0.3f, maxStraighten, Mathf.Clamp(lmoveDist*10.0f, 0.0f, 1.0f));
									mLHandFistTarget = 0.0f;
									lhanddebug += " AboveHead";
								}
							}
						}
						
						mLHandChopTarget = Mathf.Clamp(lmoveDist*33.0f, -0.2f, maxChop * 0.5f);
						
						if (lcurhandpos.y < lHipController.followWhenOff.position.y && lmoveDist > 0.02f)
						{
							mLHandStraightenTarget = maxStraighten;
							lhandCurl = 0.0f;
							mLHandChopTarget = -1.0f;
							lhanddebug += " Low";
						}

						if (uiTargetSelection.val != "None")
						{
							if (lcurhandpos.y < lHipController2.followWhenOff.position.y && lmoveDist > 0.02f)
							{
								mLHandStraightenTarget = maxStraighten;
								lhandCurl = 0.0f;
								mLHandChopTarget = -1.0f;
								lhanddebug += " Low";
							}
						}

						if (lcurhandpos.y > chestController.followWhenOff.position.y && lmoveDist > 0.03f)
						{
							mLHandChopTarget = -0.5f;
							mLHandStraightenTarget = maxStraighten * 0.5f;
							mLHandFistTarget = 0.0f;
							lthumbOut = 0.2f;
							lhanddebug += " ParChest";
						}

						if (uiTargetSelection.val != "None")
						{
							if (lcurhandpos.y > chestController2.followWhenOff.position.y && lmoveDist > 0.03f)
							{
								mLHandChopTarget = -0.5f;
								mLHandStraightenTarget = maxStraighten * 0.5f;
								mLHandFistTarget = 0.0f;
								lthumbOut = 0.2f;
								lhanddebug += " ParChest";
							}
						}

						if (lcurhandpos.y > chestController.followWhenOff.position.y && lcurhandpos.y < neckController.followWhenOff.position.y && lmoveDist < 0.0025f && lchestDist < 0.3f * uidistancescale.val)
						{
							mLHandChopTarget = 0.0f;
							mLHandStraightenTarget = 0.2f;
							mLHandFistTarget = 0.4f * uiposeadjust.val;
							lthumbOut = 0.3f;
							lhanddebug += " OnChest";
						}

						if (uiTargetSelection.val != "None")
						{
							if (lcurhandpos.y > chestController2.followWhenOff.position.y && lcurhandpos.y < neckController2.followWhenOff.position.y && lmoveDist < 0.0025f && lchestDist2 < 0.3f * uidistancescale.val)
							{
								mLHandChopTarget = 0.0f;
								mLHandStraightenTarget = 0.2f;
								mLHandFistTarget = 0.4f * uiposeadjust.val;
								lthumbOut = 0.3f;
								lhanddebug += " OnChest";
							}
						}

						lhanddir = abdomenController.followWhenOff.position - lcurhandpos;
						ldotProduct = Vector3.Dot(lhanddir, abdomenController.followWhenOff.forward);
						if (uiTargetSelection.val != "None")
						{
							ldotProduct2 = Vector3.Dot(lhanddir, abdomenController2.followWhenOff.forward);
						}
						else
						{
							ldotProduct2 = 0.0f;
						}
						if (ldotProduct > 0.3f)
						{
							mLHandStraightenTarget = 0.0f;
							mLHandFistTarget = 0.8f;
							mLHandChopTarget = 0.0f;
							lhanddebug += " AtBack";
						}
						
						if (lrhandDist < minHandDist)
						{
							mLHandStraightenTarget = maxStraighten;
							mLHandFistTarget = 0.0f;
							mLHandChopTarget = -1.0f;
							lHandRelaxAmount = 0.0f;
							lthumbOut = -0.1f;
							lhanddebug += " Hands";
						}
						if (uigenericcol.val)
						{
							if (lHandController.followWhenOffRB.SweepTest(-lHandController.followWhenOff.up, out hit, 0.1f))
							{
								hitdetected = true;
								if (lmoveDist > 0.001f)
								{
									hitDist = Mathf.Min(hit.distance, 0.08f);
								}
								//SuperController.singleton.ClearErrors();
								//SuperController.LogError("Collision " + hit.distance);
							}
							if (hitdetected || lHandCollisionTimer > 0.0f)
							{
								if (lHandCollisionTimer <= 0.0f)
								{
									lHandCollisionTimer = 0.5f;
								}
								else
								{
									lHandCollisionTimer -= Time.fixedDeltaTime;
								}
								
								mLHandStraightenTarget = maxStraighten * 0.8f * (1.0f - (hitDist * 100.0f));
								mLHandFistTarget = maxFist * 0.1f;
								mLHandChopTarget = -0.2f;
								lhanddebug += " Col";
							}
						}
						if (lfloorDist < uitoeground.val + uitoegroundclear.val)
						{
							mLHandStraightenTarget = Mathf.Lerp(maxStraighten, 0.0f, lfloorDist/(uitoeground.val + uitoegroundclear.val));
							mLHandFistTarget = 0.0f;
							mLHandChopTarget = -0.2f;
							lHandRelaxAmount = 0.0f;
							lhanddebug += " Floor";
						}
					}
					else
					{
						lhanddir = abdomenController.followWhenOff.position - lcurhandpos;
						if (lhipLDist > lhipLDist2 && lhipRDist > lhipRDist2)
						{
							ldotProduct = Vector3.Dot(lhanddir, abdomenController2.followWhenOff.forward);
							lhanddir = abdomenController2.followWhenOff.position - lcurhandpos;
						}
						else
						{
							ldotProduct = Vector3.Dot(lhanddir, abdomenController.followWhenOff.forward);
						}
						if (lhipLDist < minHipDist || lhipRDist < minHipDist || lhipLDist2 < minHipDist || lhipRDist2 < minHipDist)
						{
							if (ldotProduct > 0.1f)
							{
								mLHandStraightenTarget = 1.0f;
								mLHandFistTarget = 0.0f;
								mLHandChopTarget = 0.2f;
								lthumbOut = 0.1f;
								lhanddebug += " AtButt";
							}
							else
							{
								mLHandStraightenTarget = maxStraighten * 0.6f;
								mLHandFistTarget = maxFist * 0.3f;
								mLHandChopTarget = -0.2f;
								lthumbOut = 0.2f;
								lhanddebug += " AtHip";
							}
						}

						if (lkneeLDist < minKneeDist || lkneeRDist < minKneeDist || lkneeLDist2 < minKneeDist || lkneeRDist2 < minKneeDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.6f;
							mLHandFistTarget = maxFist * 0.2f;
							mLHandChopTarget = -0.5f;
							lthumbOut = -0.2f;
              lhanddebug += " AtKnee";
						}

						if (labsDist < minAbsDist * 2.0f || labsDist2 < minAbsDist * 2.0f)
						{
							lhanddir = abdomenController.followWhenOff.position - lcurhandpos;
							if (labsDist > labsDist2)
							{
								ldotProduct = Vector3.Dot(lhanddir, abdomenController2.followWhenOff.forward);
								lhanddir = abdomenController2.followWhenOff.position - lcurhandpos;
							}
							else
							{
								ldotProduct = Vector3.Dot(lhanddir, abdomenController.followWhenOff.forward);
							}
							if (ldotProduct > 0.1f && (labsDist < minAbsDist || labsDist2 < minAbsDist))
							{
								mLHandStraightenTarget = 0.0f;
								mLHandFistTarget = maxFist;
								mLHandChopTarget = 0.2f;
								lhanddebug += " BehindAbs";
							}
							else
							{
								if (ldotProduct > -0.2f && (labsDist < minAbsDist || labsDist2 < minAbsDist))
								{
									mLHandStraightenTarget = maxStraighten * 0.6f * uiposeadjust.val;
									mLHandFistTarget = maxFist * 0.3f;
									mLHandChopTarget = 0.1f * uiposeadjust.val;
									lHandRelaxAmount = 0.0f;
									lthumbOut = 0.2f;
									lhanddebug += " SideAbs " + ldotProduct;
								}
								else
								{
									if (labsDist < minAbsDist || labsDist2 < minAbsDist)
									{
										mLHandStraightenTarget = maxStraighten * 0.9f * uiposeadjust.val;
										mLHandFistTarget = maxFist * 0.1f;
										mLHandChopTarget = 0.2f * uiposeadjust.val;
										lHandRelaxAmount = 0.5f;
										lhanddebug += " AtAbs";
									}
								}
							}
						}
						if (lthighLDist < minThighDist || lthighRDist < minThighDist || lthighLDist2 < minThighDist || lthighRDist2 < minThighDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.6f * uiposeadjust.val;
							mLHandFistTarget = maxFist * 0.2f;
							mLHandChopTarget = 0.1f * uiposeadjust.val;
							lHandRelaxAmount = 0.0f;
              lthumbOut = -0.1f;
							lhanddebug += " Thigh";
						}
						if (lpelvisDist < minPelvisDist || lpelvisDist2 < minPelvisDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.8f * uiposeadjust.val;
							mLHandFistTarget = maxFist * 0.0f;
							mLHandChopTarget = 0.8f * uiposeadjust.val;
							lHandRelaxAmount = 0.0f;
							lthumbOut = 0.3f;
							lhanddebug += " Pelvis";
						}
						if (lchestDist < minChestDist || lchestDist2 < minChestDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.6f;
							mLHandFistTarget = maxFist * 0.3f;
							mLHandChopTarget = -0.5f;
							lthumbOut = -0.4f;
							lhanddebug += " AtChest";
						}
						if (lnippleLDist < minNippleDist || lnippleRDist < minNippleDist || lnippleLDist2 < minNippleDist || lnippleRDist2 < minNippleDist)
						{
							mLHandStraightenTarget = 0.0f;
							mLHandFistTarget = maxFist * randomValueL * uiposeadjust.val;
							mLHandChopTarget = -0.3f;
							lhandCurl = -0.4f;
							//lthumbOut = 0.2f;
							lthumbOut = 0.2f;
							lhanddebug += " AtNipple";
						}
						lhanddir = headController.followWhenOff.position - lcurhandpos;
						if (lheadDist > lheadDist2)
						{
							ldotProduct = Vector3.Dot(lhanddir, headController2.followWhenOff.forward);
							lhanddir = headController2.followWhenOff.position - lcurhandpos;
						}
						else
						{
							ldotProduct = Vector3.Dot(lhanddir, headController.followWhenOff.forward);
						}
						if (lheadDist < minHeadDist || lheadDist2 < minHeadDist)
						{
							if (ldotProduct < -0.1f)
							{
								mLHandStraightenTarget = maxStraighten * 0.8f;
								mLHandFistTarget = maxFist * 0.1f;
								mLHandChopTarget = -0.7f;
								lHandRelaxAmount = 0.2f;
								lhanddebug += " AtFace";
							}
							else
							{
								if (ldotProduct > 0.07f)
								{
									mLHandStraightenTarget = maxStraighten * 0.4f;
									mLHandFistTarget = maxFist * 0.3f;
									mLHandChopTarget = -0.1f;
									lthumbOut = -0.1f;
									lhanddebug += " BehindHead";
								}
								else
								{
									mLHandStraightenTarget = maxStraighten * 0.9f;
									mLHandFistTarget = maxFist * 0.1f;
									mLHandChopTarget = 0.3f;
									lthumbOut = -0.1f;
									lhanddebug += " SideHead";
								}
							}
						}
					}
					
					if (uidowalk.val)
					{
						Vector3 tempVector = new Vector3(0.0f,0.0f,0.0f);
						tempVector = lFootController.followWhenOff.position;
						float footangle = Vector3.Angle(lFootController.followWhenOff.forward, abdomenController.followWhenOff.forward);
						lToeController.jointRotationDriveXTarget = Mathf.Clamp(Mathf.Lerp(footangle - uitoebaseangleoffset.val, 0.0f, Mathf.Min(tempVector.y - uitoeground.val, uitoeground.val + uitoegroundclear.val) / (uitoeground.val + uitoegroundclear.val)),0.0f, uitoemaxangle.val);
						//footangle = Vector3.Angle(lFootController.followWhenOff.position - lHipController.followWhenOff.position, lHipController.followWhenOff.position);
						lToeDebug = Mathf.Lerp(footangle - uitoebaseangleoffset.val, 0.0f, Mathf.Min(tempVector.y - uitoeground.val, uitoeground.val + uitoegroundclear.val) / (uitoeground.val + uitoegroundclear.val)).ToString();

						tempVector = rFootController.followWhenOff.position;
						footangle = Vector3.Angle(rFootController.followWhenOff.forward, abdomenController.followWhenOff.forward);
						rToeController.jointRotationDriveXTarget = Mathf.Clamp(Mathf.Lerp(footangle - uitoebaseangleoffset.val, 0.0f, Mathf.Min(tempVector.y - uitoeground.val, uitoeground.val + uitoegroundclear.val) / (uitoeground.val + uitoegroundclear.val)),0.0f, uitoemaxangle.val);
						rToeDebug = Mathf.Lerp(footangle - uitoebaseangleoffset.val, 0.0f, Mathf.Min(tempVector.y - uitoeground.val, uitoeground.val + uitoegroundclear.val) / (uitoeground.val + uitoegroundclear.val)).ToString();
					}
				}

				float rhipLDist = Vector3.Distance(rcurhandpos, lHipController.followWhenOff.position);
				float rhipRDist = Vector3.Distance(rcurhandpos, rHipController.followWhenOff.position);
				float rkneeLDist = Vector3.Distance(rcurhandpos, lKneeController.followWhenOff.position);
				float rkneeRDist = Vector3.Distance(rcurhandpos, rKneeController.followWhenOff.position);
				float rthighLDist = Vector3.Distance(rcurhandpos, lHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
				float rthighRDist = Vector3.Distance(rcurhandpos, rHipController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
				float rpelvisDist = Vector3.Distance(rcurhandpos, pelvisController.followWhenOff.TransformPoint(new Vector3(0.0f,-0.17f,0.04f)));
				float rchestDist = Vector3.Distance(rcurhandpos, chestController.followWhenOff.position);
				float rnippleLDist = Vector3.Distance(rcurhandpos, lNippleController.followWhenOff.position);
				float rnippleRDist = Vector3.Distance(rcurhandpos, rNippleController.followWhenOff.position);
				float rabsDist = Vector3.Distance(rcurhandpos, abdomenController.followWhenOff.position);
				float rheadDist = Vector3.Distance(rcurhandpos, headController.followWhenOff.position);
				float rlhandDist = Vector3.Distance(lcurhandpos, rcurhandpos);
				if (uiSkipOwnHands.val == true)
				{
					rlhandDist = 99999.0f;
				}
				float rmoveDist = Vector3.Distance(rcurhandpos, rhandpos) * uimotionspeed.val;
				float rfloorDist = Mathf.Max(rcurhandpos.y, uitoeground.val);
				float rhandCurl = 1.0f;
				float rthumbOut = 0.0f;
				rHandRelaxAmount = 0.0f;
				hitdetected = false;

				float rhipLDist2 = 99999.0f;
				float rhipRDist2 = 99999.0f;
				float rkneeLDist2 = 99999.0f;
				float rkneeRDist2 = 99999.0f;
				float rthighLDist2 = 99999.0f;
				float rthighRDist2 = 99999.0f;
				float rpelvisDist2 = 99999.0f;
				float rchestDist2 = 99999.0f;
				float rnippleLDist2 = 99999.0f;
				float rnippleRDist2 = 99999.0f;
				float rabsDist2 = 99999.0f;
				float rheadDist2 = 99999.0f;
				float rlhandDist2 = 99999.0f;
				float rrhandDist2 = 99999.0f;

				if (uianimatehandr.val)
				{
					Vector3 rhanddir = chestController.followWhenOff.position - rcurhandpos;
					float rdotProduct = Vector3.Dot(rhanddir, chestController.followWhenOff.forward);
					float rdotProduct2;

					if (uiTargetSelection.val != "None")
					{
						rhipLDist2 = Vector3.Distance(rcurhandpos, lHipController2.followWhenOff.position);
						rhipRDist2 = Vector3.Distance(rcurhandpos, rHipController2.followWhenOff.position);
						rkneeLDist2 = Vector3.Distance(rcurhandpos, lKneeController2.followWhenOff.position);
						rkneeRDist2 = Vector3.Distance(rcurhandpos, rKneeController2.followWhenOff.position);
						rthighLDist2 = Vector3.Distance(rcurhandpos, lHipController2.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
						rthighRDist2 = Vector3.Distance(rcurhandpos, rHipController2.followWhenOff.TransformPoint(new Vector3(0.0f,-0.2f,0.0f)));
						rpelvisDist2 = Vector3.Distance(rcurhandpos, pelvisController2.followWhenOff.TransformPoint(new Vector3(0.0f,-0.17f,0.04f)));
						rchestDist2 = Vector3.Distance(rcurhandpos, chestController2.followWhenOff.position);
						rnippleLDist2 = Vector3.Distance(rcurhandpos, lNippleController2.followWhenOff.position);
						rnippleRDist2 = Vector3.Distance(rcurhandpos, rNippleController2.followWhenOff.position);
						rabsDist2 = Vector3.Distance(rcurhandpos, abdomenController2.followWhenOff.position);
						rheadDist2 = Vector3.Distance(rcurhandpos, headController2.followWhenOff.position);
						rlhandDist2 = Vector3.Distance(rcurhandpos, lHandController2.followWhenOff.TransformPoint(new Vector3(-0.1f, 0.0f, 0.0f)));
						rrhandDist2 = Vector3.Distance(rcurhandpos, rHandController2.followWhenOff.TransformPoint(new Vector3(0.1f, 0.0f, 0.0f)));
						rdotProduct = Vector3.Dot(rhanddir, chestController2.followWhenOff.forward);
					}
					

					if (rmoveDist > minMotion
					    || (rchestDist > minChestDist && rabsDist > minAbsDist && rheadDist > minHeadDist && rhipLDist > minHipDist && rhipRDist > minHipDist && rnippleLDist > minNippleDist && rnippleRDist > minNippleDist && rthighLDist > minThighDist && rthighRDist > minThighDist && rpelvisDist > minPelvisDist)
						&& (rchestDist2 > minChestDist && rabsDist2 > minAbsDist && rheadDist2 > minHeadDist && rhipLDist2 > minHipDist && rhipRDist2 > minHipDist && rnippleLDist2 > minNippleDist && rnippleRDist2 > minNippleDist && rthighLDist2 > minThighDist && rthighRDist2 > minThighDist && rpelvisDist2 > minPelvisDist))
					{
						if (rmoveDist > 0.02f)
						{
							mRHandStraightenTarget = maxStraighten;
							mRHandFistTarget = 0.0f;
							rhandCurl = 0.0f;
							rHandRelaxAmount = 0.0f;
							rhanddebug += " FastMove";
						}
						else
						{
							mRHandStraightenTarget = 0.0f;
							mRHandFistTarget = maxFist * 0.2f * uiposeadjust.val;
							rHandRelaxAmount = 1.0f;
							rthumbOut = -0.1f;
							rhanddebug += " Slow";
						}
						if (rcurhandpos.y > neckController.followWhenOff.position.y && rheadDist < 0.15f * uidistancescale.val)
						{
							if (rcurhandpos.y < headController.followWhenOff.position.y + 0.15f)
							{
								mRHandStraightenTarget = 0.9f;
								mRHandFistTarget = 0 * (Mathf.Clamp(rmoveDist*10.0f, 0.0f, 1.0f));
								rthumbOut = -0.1f;
								rhanddebug += " ParHead";
							}
							else
							{
								mRHandStraightenTarget = Mathf.Lerp(0.3f, maxStraighten, Mathf.Clamp(rmoveDist*10.0f, 0.0f, 1.0f));
								mRHandFistTarget = 0.0f;
								rhanddebug += " AboveHead";
							}
						}

						if (uiTargetSelection.val != "None")
						{
							if (rcurhandpos.y > neckController2.followWhenOff.position.y && rheadDist2 < 0.15f * uidistancescale.val)
							{
								if (rcurhandpos.y < headController2.followWhenOff.position.y + 0.15f)
								{
									mRHandStraightenTarget = 0.9f;
									mRHandFistTarget = 0 * (Mathf.Clamp(rmoveDist*10.0f, 0.0f, 1.0f));
									rthumbOut = -0.1f;
									rhanddebug += " ParHead";
								}
								else
								{
									mRHandStraightenTarget = Mathf.Lerp(0.3f, maxStraighten, Mathf.Clamp(rmoveDist*10.0f, 0.0f, 1.0f));
									mRHandFistTarget = 0.0f;
									rhanddebug += " AboveHead";
								}
							}
						}


						mRHandChopTarget = Mathf.Clamp(rmoveDist*33.0f, -0.2f, maxChop * 0.5f);
						
						if (rcurhandpos.y < rHipController.followWhenOff.position.y && rmoveDist > 0.02f)
						{
							mRHandStraightenTarget = maxStraighten;
							mRHandChopTarget = -1.0f;
							rhandCurl = 0.0f;
							rhanddebug += " Low";
						}

						if (uiTargetSelection.val != "None")
						{
							if (rcurhandpos.y < rHipController2.followWhenOff.position.y && rmoveDist > 0.02f)
							{
								mRHandStraightenTarget = maxStraighten;
								mRHandChopTarget = -1.0f;
								rhandCurl = 0.0f;
								rhanddebug += " Low";
							}
						}

						if (rcurhandpos.y > chestController.followWhenOff.position.y && rmoveDist > 0.03f)
						{
							mRHandChopTarget = -0.5f;
							mRHandStraightenTarget = maxStraighten * 0.5f;
							mRHandFistTarget = 0.0f;
							rthumbOut = 0.2f;
							rhanddebug += " ParChest";
						}

						if (uiTargetSelection.val != "None")
						{
							if (rcurhandpos.y > chestController2.followWhenOff.position.y && rmoveDist > 0.03f)
							{
								mRHandChopTarget = -0.5f;
								mRHandStraightenTarget = maxStraighten * 0.5f;
								mRHandFistTarget = 0.0f;
								rthumbOut = 0.2f;
								rhanddebug += " ParChest";
							}
						}


						if (rcurhandpos.y > chestController.followWhenOff.position.y && rcurhandpos.y < neckController.followWhenOff.position.y && rmoveDist < 0.0025f && rchestDist < 0.3f * uidistancescale.val)
						{
							mRHandChopTarget = 0.0f;
							mRHandStraightenTarget = 0.2f;
							mRHandFistTarget = 0.4f * uiposeadjust.val;
							rthumbOut = 0.3f;
							rhanddebug += " OnChest";
						}

						if (uiTargetSelection.val != "None")
						{
							if (rcurhandpos.y > chestController2.followWhenOff.position.y && rcurhandpos.y < neckController2.followWhenOff.position.y && rmoveDist < 0.0025f && rchestDist2 < 0.3f * uidistancescale.val)
							{
								mRHandChopTarget = 0.0f;
								mRHandStraightenTarget = 0.2f;
								mRHandFistTarget = 0.4f * uiposeadjust.val;
								rthumbOut = 0.3f;
								rhanddebug += " OnChest";
							}
						}

						rhanddir = abdomenController.followWhenOff.position - rcurhandpos;
						rdotProduct = Vector3.Dot(rhanddir, abdomenController.followWhenOff.forward);
						if (uiTargetSelection.val != "None")
						{
							rdotProduct2 = Vector3.Dot(rhanddir, abdomenController2.followWhenOff.forward);
						}
						else
						{
							rdotProduct2 = 0.0f;
						}
						if (rdotProduct > 0.3f || rdotProduct2 > 0.3f)
						{
							mRHandStraightenTarget = 0.0f;
							mRHandFistTarget = 0.8f;
							mRHandChopTarget = 0.0f;
							rhanddebug += " AtBack";
						}
						
						if (rlhandDist < minHandDist)
						{
							mRHandStraightenTarget = maxStraighten;
							mRHandFistTarget = 0.0f;
							mRHandChopTarget = -1.0f;
							rHandRelaxAmount = 0.0f;
							rthumbOut = -0.1f;
							rhanddebug += " Hands";
						}
						if (uigenericcol.val)
						{
							if (rHandController.followWhenOffRB.SweepTest(-rHandController.followWhenOff.up, out hit, 0.1f))
							{
								hitdetected = true;
								if (rmoveDist > 0.001f)
								{
									hitDist = Mathf.Min(hit.distance, 0.08f);
								}
								//SuperController.singleton.ClearErrors();
								//SuperController.LogError("Collision " + hit.distance);
							}
							if (hitdetected || rHandCollisionTimer > 0.0f)
							{
								if (rHandCollisionTimer <= 0.0f)
								{
									rHandCollisionTimer = 0.5f;
								}
								else
								{
									rHandCollisionTimer -= Time.fixedDeltaTime;
								}
								
								mRHandStraightenTarget = maxStraighten * 0.8f * (1.0f - (hitDist * 100.0f));
								mRHandFistTarget = maxFist * 0.1f;
								mRHandChopTarget = -0.2f;
								rhanddebug += " Col";
							}
						}
						if (rfloorDist < uitoeground.val + uitoegroundclear.val)
						{
							mRHandStraightenTarget = Mathf.Lerp(maxStraighten, 0.0f, rfloorDist/(uitoeground.val + uitoegroundclear.val));
							mRHandFistTarget = 0.0f;
							mRHandChopTarget = -0.2f;
							rHandRelaxAmount = 0.0f;
							rhanddebug += " Floor";
						}
					}
					else
					{
						rhanddir = abdomenController.followWhenOff.position - rcurhandpos;
						rdotProduct = Vector3.Dot(rhanddir, abdomenController.followWhenOff.forward);
						if (rhipLDist > rhipLDist2 && rhipRDist > rhipRDist2)
						{
							rdotProduct = Vector3.Dot(rhanddir, abdomenController2.followWhenOff.forward);
							rhanddir = abdomenController2.followWhenOff.position - rcurhandpos;
						}
						else
						{
							rdotProduct = Vector3.Dot(rhanddir, abdomenController.followWhenOff.forward);
						}
						if (rhipLDist < minHipDist || rhipRDist < minHipDist || rhipLDist2 < minHipDist || rhipRDist2 < minHipDist)
						{
							if (rdotProduct > 0.1f)
							{
								mRHandStraightenTarget = 1.0f;
								mRHandFistTarget = 0.0f;
								mRHandChopTarget = 0.2f;
								rthumbOut = 0.1f;
								rhanddebug += " AtButt";
							}
							else
							{
								mRHandStraightenTarget = maxStraighten * 0.6f;
								mRHandFistTarget = maxFist * 0.3f;
								mRHandChopTarget = -0.2f;
								rthumbOut = 0.2f;
								rhanddebug += " AtHip";
							}
						}

						if (rkneeLDist < minKneeDist || rkneeRDist < minKneeDist || rkneeLDist2 < minKneeDist || rkneeRDist2 < minKneeDist)
						{
							mRHandStraightenTarget = maxStraighten * 0.6f;
							mRHandFistTarget = maxFist * 0.2f;
							mRHandChopTarget = -0.5f;
							rthumbOut = -0.2f;
              rhanddebug += " AKnee";
						}

						if (rabsDist < minAbsDist * 2.0f || rabsDist2 < minAbsDist * 2.0f)
						{
							rhanddir = abdomenController.followWhenOff.position - rcurhandpos;
							if (rabsDist > rabsDist2)
							{
								rdotProduct = Vector3.Dot(rhanddir, abdomenController2.followWhenOff.forward);
								rhanddir = abdomenController2.followWhenOff.position - rcurhandpos;
							}
							else
							{
								rdotProduct = Vector3.Dot(rhanddir, abdomenController.followWhenOff.forward);
							}
							if (rdotProduct > 0.1f && (rabsDist < minAbsDist || rabsDist2 < minAbsDist))
							{
								mRHandStraightenTarget = 0.0f;
								mRHandFistTarget = maxFist;
								mRHandChopTarget = 0.2f;
								rhanddebug += " BehindAbs";
							}
							else
							{
								if (rdotProduct > -0.2f && (rabsDist < minAbsDist || rabsDist2 < minAbsDist))
								{
									mRHandStraightenTarget = maxStraighten * 0.6f * uiposeadjust.val;
									mRHandFistTarget = maxFist * 0.3f;
									mRHandChopTarget = 0.1f * uiposeadjust.val;
									rHandRelaxAmount = 0.0f;
									rthumbOut = 0.2f;
									rhanddebug += " SideAbs " + rdotProduct;
								}
								else
								{
									if (rabsDist < minAbsDist || rabsDist2 < minAbsDist)
									{
										mRHandStraightenTarget = maxStraighten * 0.9f * uiposeadjust.val;
										mRHandFistTarget = maxFist * 0.1f;
										mRHandChopTarget = 0.2f * uiposeadjust.val;
										rHandRelaxAmount = 0.5f;
										rhanddebug += " AtAbs";
									}
								}
							}
						}
						if (rthighLDist < minThighDist || rthighRDist < minThighDist || rthighLDist2 < minThighDist || rthighRDist2 < minThighDist)
						{
							mRHandStraightenTarget = maxStraighten * 0.6f * uiposeadjust.val;
							mRHandFistTarget = maxFist * 0.3f;
							mRHandChopTarget = 0.1f * uiposeadjust.val;
							rHandRelaxAmount = 0.0f;
							rhanddebug += " Thigh";
						}
						if (rpelvisDist < minPelvisDist || rpelvisDist2 < minPelvisDist)
						{
							mLHandStraightenTarget = maxStraighten * 0.8f * uiposeadjust.val;
							mLHandFistTarget = maxFist * 0.0f;
							mLHandChopTarget = 0.8f * uiposeadjust.val;
							lHandRelaxAmount = 0.0f;
							rthumbOut = 0.3f;
							rhanddebug += " Pelvis";
						}
						if (rchestDist < minChestDist || rchestDist2 < minChestDist)
						{
							mRHandStraightenTarget = maxStraighten * 0.6f;
							mRHandFistTarget = maxFist * 0.3f;
							mRHandChopTarget = -0.5f;
							rthumbOut = -0.4f;
							rhanddebug += " AtChest";
						}
						if (rnippleLDist < minNippleDist || rnippleRDist < minNippleDist || rnippleLDist2 < minNippleDist || rnippleRDist2 < minNippleDist)
						{
							mRHandStraightenTarget = 0.0f;
							mRHandFistTarget = maxFist * randomValueR * uiposeadjust.val;
							mRHandChopTarget = -0.3f;
							rhandCurl = -0.4f;
							//rthumbOut = 0.3f;
							rthumbOut = 0.2f;
							rhanddebug += " AtNipple";
						}
						rhanddir = headController.followWhenOff.position - rcurhandpos;
						if (rheadDist > rheadDist2)
						{
							rdotProduct = Vector3.Dot(rhanddir, headController2.followWhenOff.forward);
							rhanddir = headController2.followWhenOff.position - rcurhandpos;
						}
						else
						{
							rdotProduct = Vector3.Dot(rhanddir, headController.followWhenOff.forward);
						}
						if (rheadDist < minHeadDist || rheadDist2 < minHeadDist)
						{
							if (rdotProduct < -0.1f)
							{
								mRHandStraightenTarget = maxStraighten * 0.8f;
								mRHandFistTarget = maxFist * 0.1f;
								mRHandChopTarget = -0.7f;
								rHandRelaxAmount = 0.2f;
								rhanddebug += " AtFace";
							}
							else
							{
								if (rdotProduct > 0.07f)
								{
									mRHandStraightenTarget = maxStraighten * 0.4f;
									mRHandFistTarget = maxFist * 0.3f;
									mRHandChopTarget = -0.1f;
									rthumbOut = -0.1f;
									rhanddebug += " BehindHead";
								}
								else
								{
									mRHandStraightenTarget = maxStraighten * 0.9f;
									mRHandFistTarget = maxFist * 0.1f;
									mRHandChopTarget = 0.3f;
									rthumbOut = -0.1f;
									rhanddebug += " SideHead";
								}
							}
						}
					}
				}

				if (uianimatehandl.val)
				{
					if (mLHandStraightenTarget > mLHandStraightenValue + morphBufferL) { mLHandStraightenValue = Mathf.Min(mLHandStraightenValue + (mLHandStraightenTarget - mLHandStraightenValue) * (0.01f * uianimationspeed.val), mLHandStraightenTarget); }
					if (mLHandStraightenTarget < mLHandStraightenValue - morphBufferL) { mLHandStraightenValue = Mathf.Max(mLHandStraightenValue - (mLHandStraightenValue - mLHandStraightenTarget) * (0.01f * uianimationspeed.val), mLHandStraightenTarget); }
					morphLHandStraighten.morphValue = Round(mLHandStraightenValue) * uistraightenadjust.val;
					if (mLHandFistTarget > mLHandFistValue + morphBufferL) { mLHandFistValue = Mathf.Min(mLHandFistValue + (mLHandFistTarget - mLHandFistValue) * (0.03f * uianimationspeed.val), mLHandFistTarget); }
					if (mLHandFistTarget < mLHandFistValue - morphBufferL) { mLHandFistValue = Mathf.Max(mLHandFistValue - (mLHandFistValue - mLHandFistTarget) * (0.03f * uianimationspeed.val), mLHandFistTarget); }
					morphLHandFist.morphValue = Round(mLHandFistValue) * uigraspadjust.val;
					if (mLHandChopTarget > mLHandChopValue + morphBufferL) { mLHandChopValue = Mathf.Min(mLHandChopValue + (mLHandChopTarget - mLHandChopValue) * (0.03f * uianimationspeed.val), mLHandChopTarget); }
					if (mLHandChopTarget < mLHandChopValue - morphBufferL) { mLHandChopValue = Mathf.Max(mLHandChopValue - (mLHandChopValue - mLHandChopTarget) * (0.03f * uianimationspeed.val), mLHandChopTarget); }
					morphLHandChop.morphValue = Round(mLHandChopValue) * uichopadjust.val;
					if (lthumbOutActual < lthumbOut)
					{
						lthumbOutActual = Mathf.Clamp(lthumbOutActual + (0.01f * uianimationspeed.val), -1.0f, lthumbOut);
					}
					if (lthumbOutActual > lthumbOut)
					{
						lthumbOutActual = Mathf.Clamp(lthumbOutActual - (0.01f * uianimationspeed.val), lthumbOut, 1.0f);
					}
					morphLThumbGrasp.morphValue = (Round(mLHandFistValue - mLHandStraightenValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val;
					morphLThumbFist.morphValue = (Round(mLHandStraightenValue + mLHandFistValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val;//Round(mLHandFistValue - (mLHandStraightenValue / 2.0f) + (Mathf.Max(-mLHandChopValue, 0.0f)), Mathf.Lerp(-0.5f, 0.0f, Round(lmoveDist*100.0f, 0.0f, 1.0f)), 1.0f);
					morphLThumbInOut.morphValue = -uithumboffset.val * 3.0f;
					if (lhandcurlActual < lhandCurl)
					{
						lhandcurlActual = Mathf.Clamp(lhandcurlActual + (0.01f * uianimationspeed.val), -1.0f, lhandCurl);
					}
					if (lhandcurlActual > lhandCurl)
					{
						lhandcurlActual = Mathf.Clamp(lhandcurlActual - (0.01f * uianimationspeed.val), lhandCurl, 1.0f);
					}

					if (lHandRelaxAmountActual < lHandRelaxAmount)
					{
						lHandRelaxAmountActual = Mathf.Clamp(lHandRelaxAmountActual + (0.01f * uianimationspeed.val), -1.0f, lHandRelaxAmount);
					}
					if (lHandRelaxAmountActual > lHandRelaxAmount)
					{
						lHandRelaxAmountActual = Mathf.Clamp(lHandRelaxAmountActual - (0.01f * uianimationspeed.val), lHandRelaxAmount, 1.0f);
					}
					
					float tempfloat;
					tempfloat = Mathf.Clamp(Round(Mathf.Clamp((1.0f - mLHandStraightenValue) * (1.0f - (lmoveDist * 33.0f)),0.0f,1.0f) * lHandRelaxAmountActual * uifingercurl.val * lhandcurlActual), -0.2f, 1.0f);
					if (lHandRelaxActual < tempfloat)
					{
						lHandRelaxActual = Mathf.Clamp(lHandRelaxActual + (0.01f * uianimationspeed.val), -1.0f, tempfloat);
					}
					if (lHandRelaxActual > tempfloat)
					{
						lHandRelaxActual = Mathf.Clamp(lHandRelaxActual - (0.01f * uianimationspeed.val), tempfloat, 1.0f);
					}
					morphLIndexBend.morphValue = lHandRelaxActual * 0.1f;
					morphLMiddleBend.morphValue = lHandRelaxActual * 0.3f;
					morphLRingBend.morphValue = lHandRelaxActual * 0.45f;
					morphLPinkyBend.morphValue = lHandRelaxActual * 0.7f;
					if (lhanddebug != lhanddebugold)
					{
						poseSwitchCountL = Mathf.Min(poseSwitchCountL + 1, 5.0f);
					}
					else
					{
						poseSwitchCountL = Mathf.Max(poseSwitchCountL - 0.1f, 0.0f);
					}
					morphBufferL = 0.05f * poseSwitchCountL;
				}
				if (uianimatehandr.val)
				{
					if (mRHandStraightenTarget > mRHandStraightenValue + morphBufferR) { mRHandStraightenValue = Mathf.Min(mRHandStraightenValue + (mRHandStraightenTarget - mRHandStraightenValue) * (0.01f * uianimationspeed.val), mRHandStraightenTarget); }
					if (mRHandStraightenTarget < mRHandStraightenValue - morphBufferR) { mRHandStraightenValue = Mathf.Max(mRHandStraightenValue - (mRHandStraightenValue - mRHandStraightenTarget) * (0.01f * uianimationspeed.val), mRHandStraightenTarget); }
					morphRHandStraighten.morphValue = Round(mRHandStraightenValue) * uistraightenadjust.val;
					if (mRHandFistTarget > mRHandFistValue + morphBufferR) { mRHandFistValue = Mathf.Min(mRHandFistValue + (mRHandFistTarget - mRHandFistValue) * (0.03f * uianimationspeed.val), mRHandFistTarget); }
					if (mRHandFistTarget < mRHandFistValue - morphBufferR) { mRHandFistValue = Mathf.Max(mRHandFistValue - (mRHandFistValue - mRHandFistTarget) * (0.03f * uianimationspeed.val), mRHandFistTarget); }
					morphRHandFist.morphValue = Round(mRHandFistValue) * uigraspadjust.val;
					if (mRHandChopTarget > mRHandChopValue + morphBufferR) { mRHandChopValue = Mathf.Min(mRHandChopValue + (mRHandChopTarget - mRHandChopValue) * (0.03f * uianimationspeed.val), mRHandChopTarget); }
					if (mRHandChopTarget < mRHandChopValue - morphBufferR) { mRHandChopValue = Mathf.Max(mRHandChopValue - (mRHandChopValue - mRHandChopTarget) * (0.03f * uianimationspeed.val), mRHandChopTarget); }
					morphRHandChop.morphValue = Round(mRHandChopValue) * uichopadjust.val;
					if (rthumbOutActual < rthumbOut)
					{
						rthumbOutActual = Mathf.Clamp(rthumbOutActual + (0.01f * uianimationspeed.val), -1.0f, rthumbOut);
					}
					if (rthumbOutActual > rthumbOut)
					{
						rthumbOutActual = Mathf.Clamp(rthumbOutActual - (0.01f * uianimationspeed.val), rthumbOut, 1.0f);
					}
					morphRThumbGrasp.morphValue = (Round(mRHandFistValue - mRHandStraightenValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val;
					morphRThumbFist.morphValue = (Round(mRHandStraightenValue + mRHandFistValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val;//Round(mRHandFistValue - (mRHandStraightenValue / 2.0f) + (Mathf.Max(-mRHandChopValue, 0.0f)), Mathf.Lerp(-0.5f, 0.0f, Round(rmoveDist*100.0f, 0.0f, 1.0f)), 1.0f);
					morphRThumbInOut.morphValue = -uithumboffset.val * 3.0f;
					if (rhandcurlActual < rhandCurl)
					{
						rhandcurlActual = Mathf.Clamp(rhandcurlActual + (0.01f * uianimationspeed.val), -1.0f, rhandCurl);
					}
					if (rhandcurlActual > rhandCurl)
					{
						rhandcurlActual = Mathf.Clamp(rhandcurlActual - (0.01f * uianimationspeed.val), rhandCurl, 1.0f);
					}

					if (rHandRelaxAmountActual < rHandRelaxAmount)
					{
						rHandRelaxAmountActual = Mathf.Clamp(rHandRelaxAmountActual + (0.01f * uianimationspeed.val), -1.0f, rHandRelaxAmount);
					}
					if (rHandRelaxAmountActual > rHandRelaxAmount)
					{
						rHandRelaxAmountActual = Mathf.Clamp(rHandRelaxAmountActual - (0.01f * uianimationspeed.val), rHandRelaxAmount, 1.0f);
					}
					
					float tempfloat = Mathf.Clamp(Round(Mathf.Clamp((1.0f - mRHandStraightenValue) * (1.0f - (rmoveDist * 33.0f)),0.0f,1.0f) * rHandRelaxAmountActual * uifingercurl.val * rhandcurlActual), -0.2f, 1.0f);
					if (rHandRelaxActual < tempfloat)
					{
						rHandRelaxActual = Mathf.Clamp(rHandRelaxActual + (0.01f * uianimationspeed.val), -1.0f, tempfloat);
					}
					if (rHandRelaxActual > tempfloat)
					{
						rHandRelaxActual = Mathf.Clamp(rHandRelaxActual - (0.01f * uianimationspeed.val), tempfloat, 1.0f);
					}
					morphRIndexBend.morphValue = rHandRelaxActual * 0.1f;
					morphRMiddleBend.morphValue = rHandRelaxActual * 0.3f;
					morphRRingBend.morphValue = rHandRelaxActual * 0.45f;
					morphRPinkyBend.morphValue = rHandRelaxActual * 0.7f;
					if (rhanddebug != rhanddebugold)
					{
						poseSwitchCountR = Mathf.Min(poseSwitchCountR + 1, 5.0f);
					}
					else
					{
						poseSwitchCountR = Mathf.Max(poseSwitchCountR - 0.1f, 0.0f);
					}
					morphBufferR = 0.05f * poseSwitchCountR;
				}
					//if (lthumbOut > lthumbOutActual) { lthumbOutActual = (Mathf.Min((lthumbOut * 1000.0f) + 1.0f, (lthumbOut * 1000.0f)))/1000.0f; }
					//if (lthumbOut < lthumbOutActual) { lthumbOutActual = (Mathf.Max((lthumbOut * 1000.0f) - 1.0f, (lthumbOut * 1000.0f)))/1000.0f; }
					//if (rthumbOut > rthumbOutActual) { rthumbOutActual = Mathf.Min(rthumbOut + 1.0f, rthumbOut); }
					//if (rthumbOut < rthumbOutActual) { rthumbOutActual = Mathf.Max(rthumbOut - 1.0f, rthumbOut); }
				//SuperController.LogMessage("value " + lthumbOutActual + " (" + lthumbOut + ")", false);

					lhanddebugold = lhanddebug;
					rhanddebugold = rhanddebug;
					
					if (uiShowStats.val)
					{
						SuperController.singleton.ClearMessages();
						SuperController.LogMessage(lhanddebug, false);
						SuperController.LogMessage(rhanddebug, false);
						SuperController.LogMessage(lToeDebug, false);
						SuperController.LogMessage(rToeDebug, false);
						SuperController.LogMessage("Random Value " + Round(randomValueL), false);		
						SuperController.LogMessage("Random Value " + Round(randomValueR), false);		
						SuperController.LogMessage("Left Grasp " + Round(mLHandFistValue), false);		
						SuperController.LogMessage("Right Grasp " + Round(mRHandFistValue), false);		
						SuperController.LogMessage("Left Straighten " + Round(mLHandStraightenValue), false);		
						SuperController.LogMessage("Right Straighten " + Round(mRHandStraightenValue), false);

						SuperController.LogMessage("Left Thumb Grasp " + Round((Round(mLHandFistValue - mLHandStraightenValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val), false);		
						SuperController.LogMessage("Right Thumb Grasp " + Round((Round(mRHandFistValue - mRHandStraightenValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val), false);
						SuperController.LogMessage("Left Thumb Fist " + Round((Round(mLHandStraightenValue + mLHandFistValue) * uithumbadjust.val) - lthumbOutActual + uithumboffset.val), false);		
						SuperController.LogMessage("Right Thumb Fist " + Round((Round(mRHandStraightenValue + mRHandFistValue) * uithumbadjust.val) - rthumbOutActual + uithumboffset.val), false);
						SuperController.LogMessage("ui Thumb Offset " + uithumboffset.val, false);		
						SuperController.LogMessage("ui Thumb Adjust " + uithumbadjust.val, false);

						SuperController.LogMessage("Left Thumb Out " + Round(lthumbOutActual), false);
						SuperController.LogMessage("Right Thumb Out " + Round(rthumbOutActual), false);						
						SuperController.LogMessage("Left Chop " + Round(mLHandChopValue), false);		
						SuperController.LogMessage("Right Chop " + Round(mRHandChopValue), false);		
						SuperController.LogMessage("Left Relax " + Round(lHandRelaxActual), false);		
						SuperController.LogMessage("Right Relax " + Round(rHandRelaxActual), false);		
						SuperController.LogMessage("Left Relax Amount " + Round(lHandRelaxAmount), false);		
						SuperController.LogMessage("Right Relax Amount " + Round(rHandRelaxAmount), false);		
						SuperController.LogMessage("Left Curl " + Round(lhandcurlActual), false);		
						SuperController.LogMessage("Right Curl " + Round(rhandcurlActual), false);		
						
						SuperController.LogMessage("", false);
						SuperController.LogMessage("Own Body", false);
						SuperController.LogMessage("lhipLDist " + Round(lhipLDist), false);
						SuperController.LogMessage("lhipRDist " + Round(lhipRDist), false);
						SuperController.LogMessage("lthighLDist " + Round(lthighLDist), false);
						SuperController.LogMessage("lthighRDist " + Round(lthighRDist), false);
						SuperController.LogMessage("lpelvisDist " + Round(lpelvisDist), false);
						SuperController.LogMessage("lchestDist " + Round(lchestDist), false);
						SuperController.LogMessage("lnippleLDist " + Round(lnippleLDist), false);
						SuperController.LogMessage("lnippleRDist " + Round(lnippleRDist), false);
						SuperController.LogMessage("labsDist " + Round(labsDist), false);
						SuperController.LogMessage("lheadDist " + Round(lheadDist), false);
						SuperController.LogMessage("lrhandDist " + Round(lrhandDist), false);
						SuperController.LogMessage("lmoveDist " + Round(lmoveDist), false);
						SuperController.LogMessage("", false);
						SuperController.LogMessage("rhipLDist " + Round(rhipLDist), false);
						SuperController.LogMessage("rhipRDist " + Round(rhipRDist), false);
						SuperController.LogMessage("rthighLDist " + Round(rthighLDist), false);
						SuperController.LogMessage("rthighRDist " + Round(rthighRDist), false);
						SuperController.LogMessage("rpelvisDist " + Round(rpelvisDist), false);
						SuperController.LogMessage("rchestDist " + Round(rchestDist), false);
						SuperController.LogMessage("rnippleLDist " + Round(rnippleLDist), false);
						SuperController.LogMessage("rnippleRDist " + Round(rnippleRDist), false);
						SuperController.LogMessage("rabsDist " + Round(rabsDist), false);
						SuperController.LogMessage("rheadDist " + Round(rheadDist), false);
						SuperController.LogMessage("rlhandDist " + Round(rlhandDist), false);
						SuperController.LogMessage("rmoveDist " + Round(rmoveDist), false);		
						SuperController.LogMessage("", false);
						SuperController.LogMessage("Other Body", false);
						SuperController.LogMessage("lhipLDist2 " + Round(lhipLDist2), false);
						SuperController.LogMessage("lhipRDist2 " + Round(lhipRDist2), false);
						SuperController.LogMessage("lthighLDist2 " + Round(lthighLDist2), false);
						SuperController.LogMessage("lthighRDist2 " + Round(lthighRDist2), false);
						SuperController.LogMessage("lpelvisDist2 " + Round(lpelvisDist2), false);
						SuperController.LogMessage("lchestDist2 " + Round(lchestDist2), false);
						SuperController.LogMessage("lnippleLDist2 " + Round(lnippleLDist2), false);
						SuperController.LogMessage("lnippleRDist2 " + Round(lnippleRDist2), false);
						SuperController.LogMessage("labsDist2 " + Round(labsDist2), false);
						SuperController.LogMessage("lheadDist2 " + Round(lheadDist2), false);
						SuperController.LogMessage("lrhandDist2 " + Round(lrhandDist2), false);
						SuperController.LogMessage("", false);
						SuperController.LogMessage("rhipLDist2 " + Round(rhipLDist2), false);
						SuperController.LogMessage("rhipRDist2 " + Round(rhipRDist2), false);
						SuperController.LogMessage("rthighLDist2 " + Round(rthighLDist2), false);
						SuperController.LogMessage("rthighRDist2 " + Round(rthighRDist2), false);
						SuperController.LogMessage("rpelvisDist2 " + Round(rpelvisDist2), false);
						SuperController.LogMessage("rchestDist2 " + Round(rchestDist2), false);
						SuperController.LogMessage("rnippleLDist2 " + Round(rnippleLDist2), false);
						SuperController.LogMessage("rnippleRDist2 " + Round(rnippleRDist2), false);
						SuperController.LogMessage("rabsDist2 " + Round(rabsDist2), false);
						SuperController.LogMessage("rheadDist2 " + Round(rheadDist2), false);
						SuperController.LogMessage("rlhandDist2 " + Round(rlhandDist2), false);
           
					}				
				
				lhandpos = lcurhandpos;
				rhandpos = rcurhandpos;
			}
			catch (Exception e) {
				SuperController.LogError("Exception caught: " + e);
			}
		}

		// OnDestroy is where you should put any cleanup
		// if you registered objects to supercontroller or atom, you should unregister them here
		void OnDestroy() {
		}
		
		public static float Round(float value)
		{
			return Mathf.Round(value * 100.0f) / 100.0f;
		}
	}
}